/*    SNAKE is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      SNAKE is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with SNAKE.  If not, see <http://www.gnu.org/licenses/>.

____________________________________________________________________________________

     Author: Federico Salotti
     Organization/Company: Mr_Robot_Computers_Repair
     Country: Italy Barga(LU)
     Release: 0.1 (23 January 2019 02:07)

*/


class Game
{
public:
	Game()
	{
		for(int y=0; y < HEIGHT/CELL_H; y++)
		{
			for(int x=0; x < WIDTH/CELL_W; x++)
			{
				sf::RectangleShape cell(sf::Vector2f(CELL_W,CELL_H));
				//cell.setOutlineThickness(1);
				//cell.setOutlineColor(sf::Color::White);
				cell.setFillColor(sf::Color::Transparent);
				cell.setPosition(x*CELL_W,y*CELL_H);
				this->_grid.push_back(cell);
			}
		}
	}

	void getSnake(std::vector<sf::Vector2f> snake)
	{
		this->_snake=snake;
	}

	void generateFruit()
	{
		this->_fruit.x=(rand()%39+1)*16;
		this->_fruit.y=(rand()%29+1)*16;
	}

	void update(Snake &snake,unsigned int &score)
	{

		for(auto &cell : this->_grid)
		{
			for(auto &snake_part : this->_snake)
			{
				if(cell.getPosition().x == snake_part.x && cell.getPosition().y == snake_part.y)
				{
					cell.setOutlineThickness(1);
					cell.setOutlineColor(sf::Color::Blue);
					cell.setFillColor(sf::Color::Green);
					break;
				}

				else if(this->_fruit.x == snake.getPosition().at(0).x && this->_fruit.y == snake.getPosition().at(0).y)
				{
					snake.grow();
					generateFruit();
					score+=1;
				}
				else if(this->_fruit.x == cell.getPosition().x && this->_fruit.y == cell.getPosition().y)
				{
					cell.setOutlineThickness(1);
					cell.setOutlineColor(sf::Color::Blue);
					cell.setFillColor(sf::Color::Red);
				}

				else if(snake_part.x > 624)
					snake.reset(0,snake_part.y);

				else if(snake_part.x < 0)
					snake.reset(624,snake_part.y);

				else if(snake_part.y > 464)
					snake.reset(snake_part.x,0);

				else if(snake_part.y < 0)
					snake.reset(snake_part.x,464);

				else
				{
				//	cell.setOutlineThickness(0);
					cell.setFillColor(sf::Color::Transparent);
				}
			}
		}

	}

	void clearTrack()
	{
		for(auto &cell : this->_grid)
			if(cell.getOutlineThickness() != 0)
				cell.setOutlineThickness(0);
	}

	void draw(sf::RenderWindow &window)
	{
		for(auto  &cell : this->_grid) window.draw(cell);
	}
private:
std::vector<sf::RectangleShape> _grid;
std::vector<sf::Vector2f> _snake;
sf::Vector2f _fruit;
};
